﻿namespace UltraGridCellCollSpan
{
    using System.Drawing;
    using System.Linq;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    internal class MyCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            CellUIElement cellElement = parent as CellUIElement;

            if (cellElement != null)
            {
                CellUIElement keyCellElement = null; 
                foreach (CellUIElement cell in cellElement.Parent.ChildElements)
                {
                    if (cell.Column.Header.Caption == "KEY")
                    {
                        keyCellElement = cell;
                        break;
                    }
                }

                if (keyCellElement.Cell.Text == "*")
                {
                    if (cellElement.Cell.Column.Header.Caption == "COMMENT")
                    {
                        int keyCellWidth = 0;
                        if (keyCellElement != null)
                        {
                            keyCellWidth += keyCellElement.Rect.Width;
                        }

                        int w = cellElement.Parent.Rect.Width - keyCellWidth - 1;
                        cellElement.Rect = new Rectangle(cellElement.Parent.Rect.X + keyCellElement.Cell.Column.Width - 1, cellElement.Rect.Y, w, cellElement.Rect.Height);
                    }
                    else if (cellElement.Cell.Column.Header.Caption != "KEY")
                    {
                        cellElement.Parent.ChildElements.Remove(cellElement);
                    }
                }
            }

            return false;
        }
    }
}