﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Friend Class MyCreationFilter
    Implements IUIElementCreationFilter
    Public Sub AfterCreateChildElements(parent As UIElement) Implements IUIElementCreationFilter.AfterCreateChildElements
    End Sub

    Public Function BeforeCreateChildElements(parent As UIElement) As Boolean Implements IUIElementCreationFilter.BeforeCreateChildElements
        Dim commentCellElement As CellUIElement = TryCast(parent, CellUIElement)

        If commentCellElement IsNot Nothing Then
            Dim commentCell As UltraGridCell = commentCellElement.Cell
            Dim keyCell As UltraGridCell = commentCell.Row.Cells("KEY")

            If keyCell.Text = "*" Then
                Dim parentElement As UIElement = commentCellElement.Parent
                Dim keyCellElement As CellUIElement = Nothing
                If commentCell.Column.Header.Caption = "COMMENT" Then
                    For Each cell As CellUIElement In parentElement.ChildElements
                        If cell.Column.Header.Caption = "KEY" Then
                            keyCellElement = cell
                            Exit For
                        End If
                    Next

                    Dim keyCellWidth As Integer = 0
                    If keyCellElement IsNot Nothing Then
                        keyCellWidth += keyCellElement.Rect.Width
                    End If

                    Dim width As Integer = parentElement.Rect.Width - keyCellWidth - 1
                    commentCellElement.Rect = New Rectangle(parentElement.Rect.X + keyCell.Column.Width - 1, commentCellElement.Rect.Y, width, commentCellElement.Rect.Height)
                ElseIf commentCell.Column.Header.Caption <> "KEY" Then
                    parentElement.ChildElements.Remove(commentCellElement)
                End If
            End If
        End If

        Return False
    End Function
End Class
